VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "OLE Callback test"
   ClientHeight    =   1965
   ClientLeft      =   1140
   ClientTop       =   1515
   ClientWidth     =   4035
   ControlBox      =   0   'False
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   1965
   ScaleWidth      =   4035
   Begin VB.CommandButton cmdCancel 
      Caption         =   "&Cancel"
      Enabled         =   0   'False
      Height          =   435
      Left            =   1500
      TabIndex        =   1
      ToolTipText     =   "Cancel a running task"
      Top             =   1020
      Width           =   1035
   End
   Begin VB.CommandButton cmdGo 
      Caption         =   "&Go"
      Default         =   -1  'True
      Height          =   435
      Left            =   120
      TabIndex        =   0
      ToolTipText     =   "Start the task"
      Top             =   1020
      Width           =   1035
   End
   Begin VB.CommandButton cmdExit 
      Cancel          =   -1  'True
      Caption         =   "E&xit"
      Height          =   435
      Left            =   2880
      TabIndex        =   2
      ToolTipText     =   "Terminate the application"
      Top             =   1020
      Width           =   1035
   End
   Begin VB.Label lblPercentDone 
      Alignment       =   2  'Center
      Caption         =   "0"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   780
      TabIndex        =   3
      Top             =   300
      Width           =   2475
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Based on Warren Bedell's Test4 Event example
'Modified to use OLE callbacks, based
'on Chapter 11 from Dan Appleman's book:
'Developing ActiveX Components with Visual Basic 5.0

Option Explicit

'*OLD* Private WithEvents foTest    As CEventTest
Private foTest    As CEventTest
Private fbCancel  As Boolean

Private Sub cmdCancel_Click()

    fbCancel = True

End Sub

Private Sub cmdExit_Click()

    Unload Me

End Sub

Private Sub cmdGo_Click()

    fbCancel = False
    lblPercentDone.Caption = "0%"
    
    DoEvents

    Me.MousePointer = vbArrowHourglass
    cmdCancel.Enabled = True
    cmdGo.Enabled = False
    cmdExit.Enabled = False
    DoEvents

    'Start a long running process in
    'the class module
    
    '*OLD* foTest.LongTask 5, 0.5
    foTest.LongTask Me, 5, 0.5

    cmdExit.Enabled = True
    cmdGo.Enabled = True
    cmdCancel.Enabled = False
    Me.MousePointer = vbDefault
    DoEvents

    If Not fbCancel Then
        lblPercentDone.Caption = "Done"
    Else
        lblPercentDone.Caption = "Canceled"
    End If

End Sub

Public Sub PercentDone(ByVal afPercent As Single, _
    abCancel As Boolean)

'Changed from Event of foTest to
'a method of the Form

'*OLD* Private Sub foTest_PercentDone(ByVal afPercent As Single, _
    abCancel As Boolean)

    'This event is raised by the CEventText
    'class, which returns the Percent value,
    'which we display
    
    'We also pass the value of Cancel back to
    'the class in the second argument. This will
    'be true if we press the Cancel button
    
    lblPercentDone.Caption = CInt(100 * afPercent) & "%"

    DoEvents

    abCancel = fbCancel

End Sub

Private Sub Form_Terminate()

    Set foTest = Nothing

End Sub

Private Sub Form_Initialize()
    
    Set foTest = New CEventTest

End Sub
    

